/* ---------- my_canvas  my gui-canvas for a window ---------------- */

t_widgetbehavior my_canvas_widgetbehavior;
static t_class *my_canvas_class;

typedef struct _my_canvas
{
     t_object x_obj;
     t_glist *x_glist;
     int      x_size;
     int      x_w;
     int      x_h;
     char     x_font[16];
     int      x_fontsize;
     int      x_ldx;
     int      x_ldy;
     int      x_bcol;
     int      x_lcol;
     int      x_rcv_able;
     int      x_selected;
     int      x_shiftdown;
     t_symbol *x_lab;
     t_symbol *x_rcv;
} t_my_canvas;

/* widget helper functions */

void my_canvas_draw(t_my_canvas *x, t_glist *glist, int firsttime)
{
    t_canvas *canvas=glist_getcanvas(glist);

    if(firsttime)
    {
        sys_vgui(".x%x.c create rectangle %d %d %d %d -fill %s -outline %s -tags %xRECT\n",
		 canvas, x->x_obj.te_xpos, x->x_obj.te_ypos,
		 x->x_obj.te_xpos + x->x_w, x->x_obj.te_ypos + x->x_h,
		 iem_gui_color_str[x->x_bcol], iem_gui_color_str[x->x_bcol], x);
	sys_vgui(".x%x.c create rectangle %d %d %d %d -outline %s -tags %xBASE\n",
		 canvas, x->x_obj.te_xpos, x->x_obj.te_ypos,
		 x->x_obj.te_xpos + x->x_size, x->x_obj.te_ypos + x->x_size,
		 iem_gui_color_str[x->x_bcol], x);
        if(!strcmp(x->x_lab->s_name, "empty"))
	    sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy,
		     "", x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
        else
            sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy,
		     x->x_lab->s_name, x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
    }
    else
    {
        sys_vgui(".x%x.c coords %xRECT %d %d %d %d\n",
		 canvas, x, x->x_obj.te_xpos, x->x_obj.te_ypos, x->x_obj.te_xpos + x->x_w,
		 x->x_obj.te_ypos + x->x_h);
	sys_vgui(".x%x.c coords %xBASE %d %d %d %d\n",
		 canvas, x, x->x_obj.te_xpos, x->x_obj.te_ypos,
		 x->x_obj.te_xpos + x->x_size, x->x_obj.te_ypos + x->x_size);
        sys_vgui(".x%x.c coords %xLABEL %d %d\n",
		 canvas, x, x->x_obj.te_xpos+x->x_ldx,
		     x->x_obj.te_ypos+x->x_ldy);
    }
}

void my_canvas_erase(t_my_canvas* x, t_glist* glist)
{
    t_canvas *canvas=glist_getcanvas(glist);

    sys_vgui(".x%x.c delete %xBASE\n", canvas, x);
    sys_vgui(".x%x.c delete %xRECT\n", canvas, x);
    sys_vgui(".x%x.c delete %xLABEL\n", canvas, x);
}

/* ------------------------ bg widgetbehaviour----------------------------- */

static void my_canvas_getrect(t_gobj *z, t_glist *owner, int *xp1, int *yp1, int *xp2, int *yp2)
{
    t_my_canvas *x = (t_my_canvas *)z;

    *xp1 = x->x_obj.te_xpos;
    *yp1 = x->x_obj.te_ypos;
    *xp2 = x->x_obj.te_xpos + x->x_size;
    *yp2 = x->x_obj.te_ypos + x->x_size;
}

static void my_canvas_displace(t_gobj *z, t_glist *glist, int dx, int dy)
{
    t_my_canvas *x = (t_my_canvas *)z;

    x->x_obj.te_xpos += dx;
    x->x_obj.te_ypos += dy;
    my_canvas_draw(x, glist, 0);
}

static void my_canvas_select(t_gobj *z, t_glist *glist, int selected)
{
    t_my_canvas *x = (t_my_canvas *)z;
    t_canvas *canvas=glist_getcanvas(glist);

    x->x_selected = selected;
    if(selected)
    {
        pd_bind(&x->x_obj.ob_pd, iem_gui_key_sym);
        sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
        sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
    }
    else
    {
        pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
        sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x, iem_gui_color_str[x->x_bcol]);
	sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x, iem_gui_color_str[x->x_lcol]);
    }
}

static void my_canvas_delete(t_gobj *z, t_glist *glist)
{
}

static void my_canvas_vis(t_gobj *z, t_glist *glist, int vis)
{
    t_my_canvas *x = (t_my_canvas *)z;

    if(vis)
	my_canvas_draw(x, glist, 1);
    else
	my_canvas_erase(x, glist);
}

static void my_canvas_save(t_gobj *z, t_binbuf *b)
{
    t_my_canvas *x = (t_my_canvas *)z;

    binbuf_addv(b, "ssiisiiissiiiiii", gensym("#X"),gensym("obj"),
		(t_int)x->x_obj.te_xpos, (t_int)x->x_obj.te_ypos,
		gensym("my_canvas"), x->x_size, x->x_w, x->x_h,
		x->x_rcv, x->x_lab, x->x_ldx, x->x_ldy,
                (int)(x->x_font[0]-'a'+1)/8, x->x_fontsize,
		x->x_bcol, x->x_lcol);
    binbuf_addv(b, ";");
}

static void my_canvas_properties(t_gobj *z, t_glist *owner)
{
    t_my_canvas *x = (t_my_canvas *)z;
    char buf[600];

    /*new-beg*/
    str_xch_dollar2raute(x->x_rcv);
    /*new-end*/
    sprintf(buf, "pdtk_iemgui_dialog %%s MY_CANVAS \
	    ------selectable_dimensions(pix):------ %g %g size: 0.0 0.0 empty \
	    ------visible_rectangle(pix)(pix):------ %g width: %g height: %g \
	    %g empty empty %g %g \
	    %s %s \
	    %s %g %g \
            %g %g \
	    %g %s \
            %g %s \
	    %g %s\n",
	    (float)x->x_size, 1.0,
	    (float)x->x_w, (float)x->x_h, 0.0,/*no_schedule*/
	    -1.0, -1.0, -1.0,/*no linlog, no init, no multi*/
	    "nosndno", x->x_rcv->s_name,/*no send*/
	    x->x_lab->s_name, (float)x->x_ldx, (float)x->x_ldy,
            (float)((int)(x->x_font[0]-'a'+1)/8), (float)x->x_fontsize,
            (float)x->x_bcol, iem_gui_color_str[x->x_bcol],
	    -1.0, iem_gui_color_str[0],/*no frontcolor*/
	    (float)x->x_lcol, iem_gui_color_str[x->x_lcol]);
    gfxstub_new(&x->x_obj.ob_pd, x, buf);
    /*new-beg*/
    str_xch_raute2dollar(x->x_rcv);
    /*new-end*/
}

static void my_canvas_dialog(t_my_canvas *x, t_symbol *s, int argc, t_atom *argv)
{
    char font[20];
    t_canvas *canvas=glist_getcanvas(x->x_glist);
    int a = (int)atom_getintarg(0, argc, argv);
    int w = (int)atom_getintarg(2, argc, argv);
    int h = (int)atom_getintarg(3, argc, argv);
    t_symbol *rcv = atom_getsymbolarg(8, argc, argv);
    t_symbol *lab = atom_getsymbolarg(9, argc, argv);
    int ldx = (int)atom_getintarg(10, argc, argv);
    int ldy = (int)atom_getintarg(11, argc, argv);
    int f = (int)atom_getintarg(12, argc, argv);
    int fs = (int)atom_getintarg(13, argc, argv);
    int bcol = (int)atom_getintarg(14, argc, argv);
    int lcol = (int)atom_getintarg(16, argc, argv);
    int rcvable=1;

    /*new-beg*/
    str_xch_raute2dollar(rcv);
    /*new-end*/
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(rcv->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
            x->x_rcv = rcv;
            pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_rcv_able = rcvable;
    if(a < 1)
	a = 1;
    x->x_size = a;
    if(w < 1)
	w = 1;
    x->x_w = w;
    if(h < 1)
	h = 1;
    x->x_h = h;
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    if(fs < 4)
        fs = 4;
    x->x_fontsize = fs;

    sys_vgui(".x%x.c itemconfigure %xRECT -fill %s -outline %s\n", canvas, x,
	     iem_gui_color_str[x->x_bcol], iem_gui_color_str[x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x,
	         x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_bcol]);
    if(!strcmp(x->x_lab->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol], "");
    else
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol],
		 x->x_lab->s_name);
    my_canvas_draw(x, x->x_glist, 0);
}

static void my_canvas_size(t_my_canvas *x, t_float size)
{
    if(size < 1.0)
        size = 1.0;
    
    x->x_size = (int)size;
    my_canvas_draw(x, x->x_glist, 0);
}

static void my_canvas_delta(t_my_canvas *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_obj.te_xpos += (int)atom_getintarg(0, ac, av);
    x->x_obj.te_ypos += (int)atom_getintarg(1, ac, av);
    my_canvas_draw(x, x->x_glist, 0);
}

static void my_canvas_pos(t_my_canvas *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_obj.te_xpos = (int)atom_getintarg(0, ac, av);
    x->x_obj.te_ypos = (int)atom_getintarg(1, ac, av);
    my_canvas_draw(x, x->x_glist, 0);
}

static void my_canvas_vis_size(t_my_canvas *x, t_symbol *s, int ac, t_atom *av)
{
    int i;

    i = (int)atom_getintarg(0, ac, av);
    if(i < 1)
	i = 1;
    x->x_w = i;
    i = (int)atom_getintarg(1, ac, av);
    if(i < 1)
	i = 1;
    x->x_h = i;
    my_canvas_draw(x, x->x_glist, 0);
}

static void my_canvas_color(t_my_canvas *x, t_symbol *s, int ac, t_atom *av)
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);

    x->x_bcol = iem_gui_modulo_color((int)atom_getintarg(0, ac, av));
    x->x_lcol = iem_gui_modulo_color((int)atom_getintarg(1, ac, av));
    sys_vgui(".x%x.c itemconfigure %xRECT -fill %s -outline %s\n", canvas, x,
	     iem_gui_color_str[x->x_bcol], iem_gui_color_str[x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x,
	         x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_bcol]);
    if(!strcmp(x->x_lab->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol], "");
    else
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol],
		 x->x_lab->s_name);
}

static void my_canvas_receive(t_my_canvas *x, t_symbol *s)
{
    int rcvable=1;
    /*new-beg*/
    str_xch_raute2dollar(s);
    /*new-end*/
    if(!strcmp(s->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(s->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
            x->x_rcv = s;
            pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_rcv_able = rcvable;
}

static void my_canvas_label(t_my_canvas *x, t_symbol *s)
{
    x->x_lab = s;
    if(!strcmp(s->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n",
		 glist_getcanvas(x->x_glist), x, "");
    else
	sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n",
		 glist_getcanvas(x->x_glist), x, s->s_name);
}

static void my_canvas_label_pos(t_my_canvas *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_ldx = (int)atom_getintarg(0, ac, av);
    x->x_ldy = (int)atom_getintarg(1, ac, av);
    sys_vgui(".x%x.c coords %xLABEL %d %d\n", glist_getcanvas(x->x_glist), x,
	     x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy);
}

static void my_canvas_label_font(t_my_canvas *x, t_symbol *s, int ac, t_atom *av)
{
    int f = (int)atom_getintarg(0, ac, av);

    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    f = (int)atom_getintarg(1, ac, av);
    if(f < 4)
        f = 4;
    x->x_fontsize = f;
    sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold}\n",
	     glist_getcanvas(x->x_glist), x, x->x_font, x->x_fontsize);
}

static void my_canvas_list(t_my_canvas *x, t_symbol *s, int ac, t_atom *av)
{
    if(x->x_selected)
    {
	t_symbol *key = atom_getsymbolarg(1, ac, av);
	int keydown = atom_getintarg(0, ac, av);

	if(keydown)
	{
	    int refresh = 1,i,d=1;
	    static char buf[20];

	    buf[0] = 0;
	    if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		x->x_shiftdown = 1;
	    else
	    {
		if(x->x_shiftdown)
		    d = 10;

		if(!strcmp(key->s_name, "Up"))
		    x->x_obj.te_ypos -= d;
		else if(!strcmp(key->s_name, "Down"))
		    x->x_obj.te_ypos += d;
		else if(!strcmp(key->s_name, "Left"))
		    x->x_obj.te_xpos -= d;
		else if(!strcmp(key->s_name, "Right"))
		    x->x_obj.te_xpos += d;
		else
		    refresh = 0;
		if(refresh)
		{
		    my_canvas_draw(x, x->x_glist, 0);
		}
	    }
	}
	else
	{
	    if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		x->x_shiftdown = 0;
	}
    }
    else
        post("error: my_canvas: no method for 'list'");
}

static void *my_canvas_new(t_symbol *s, int argc, t_atom *argv)
{
    t_my_canvas *x = (t_my_canvas *)pd_new(my_canvas_class);
    int bcol=IEM_GUI_COLNR_LL_GREY, lcol=IEM_GUI_COLNR_D_GREY;
    int a=IEM_GUI_DEFAULTSIZE, w=100, h=60;
    int ldx=20, ldy=12, f=2, fs=20;
    int rcvable=1;
    t_symbol *rcv = gensym("empty"), *lab = gensym("empty");


    if((argc == 10)&&IS_A_FLOAT(argv,0)&&IS_A_FLOAT(argv,1)&&IS_A_FLOAT(argv,2)
       &&IS_A_SYMBOL(argv,3)&&IS_A_FLOAT(argv,4)&&IS_A_FLOAT(argv,5)
       &&IS_A_FLOAT(argv,6)&&IS_A_FLOAT(argv,7)&&IS_A_FLOAT(argv,8)&&IS_A_FLOAT(argv,9))
    {
        a = (int)atom_getintarg(0, argc, argv);
	w = (int)atom_getintarg(1, argc, argv);
	h = (int)atom_getintarg(2, argc, argv);
	lab = atom_getsymbolarg(3, argc, argv);
	ldx = (int)atom_getintarg(4, argc, argv);
	ldy = (int)atom_getintarg(5, argc, argv);
        f = (int)atom_getintarg(6, argc, argv);
        fs = (int)atom_getintarg(7, argc, argv);
        bcol = (int)atom_getintarg(8, argc, argv);
	lcol = (int)atom_getintarg(9, argc, argv);
    }
    else if((argc == 11)&&IS_A_FLOAT(argv,0)&&IS_A_FLOAT(argv,1)&&IS_A_FLOAT(argv,2)
       &&IS_A_SYMBOL(argv,3)&&IS_A_SYMBOL(argv,4)&&IS_A_FLOAT(argv,5)&&IS_A_FLOAT(argv,6)
       &&IS_A_FLOAT(argv,7)&&IS_A_FLOAT(argv,8)&&IS_A_FLOAT(argv,9)&&IS_A_FLOAT(argv,10))
    {
        a = (int)atom_getintarg(0, argc, argv);
	w = (int)atom_getintarg(1, argc, argv);
	h = (int)atom_getintarg(2, argc, argv);
        rcv = atom_getsymbolarg(3, argc, argv);
	lab = atom_getsymbolarg(4, argc, argv);
	ldx = (int)atom_getintarg(5, argc, argv);
	ldy = (int)atom_getintarg(6, argc, argv);
        f = (int)atom_getintarg(7, argc, argv);
        fs = (int)atom_getintarg(8, argc, argv);
        bcol = (int)atom_getintarg(9, argc, argv);
	lcol = (int)atom_getintarg(10, argc, argv);
    }
    x->x_glist = (t_glist *)canvas_getcurrent();
    if(a < 1)
	a = 1;
    x->x_size = a;
    if(w < 1)
	w = 1;
    x->x_w = w;
    if(h < 1)
	h = 1;
    x->x_h = h;
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable) pd_bind(&x->x_obj.ob_pd, rcv);
    x->x_rcv_able = rcvable;
    x->x_rcv = rcv;
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    if(fs < 4)
        fs = 4;
    x->x_fontsize = fs;
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_selected = 0;
    x->x_shiftdown = 0;
    return (x);
}

static void my_canvas_ff(t_my_canvas *x)
{
    if(x->x_selected)
	pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
    if(x->x_rcv_able)
	pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
}

void my_canvas_setup(void)
{
    my_canvas_class = class_new(gensym("my_canvas"), (t_newmethod)my_canvas_new,
			     (t_method)my_canvas_ff, sizeof(t_my_canvas), CLASS_NOINLET, A_GIMME, 0);
    class_addcreator((t_newmethod)my_canvas_new, gensym("cnv"), A_GIMME, 0);
    class_addlist(my_canvas_class, my_canvas_list);
    class_addmethod(my_canvas_class, (t_method)my_canvas_dialog, gensym("dialog"), A_GIMME, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_size, gensym("size"), A_DEFFLOAT, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_delta, gensym("delta"), A_GIMME, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_pos, gensym("pos"), A_GIMME, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_vis_size, gensym("vis_size"), A_GIMME, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_color, gensym("color"), A_GIMME, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_receive, gensym("receive"), A_DEFSYM, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_label, gensym("label"), A_DEFSYM, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_label_pos, gensym("label_pos"), A_GIMME, 0);
    class_addmethod(my_canvas_class, (t_method)my_canvas_label_font, gensym("label_font"), A_GIMME, 0);

    if(!iem_gui_key_sym)
	iem_gui_key_sym = gensym("#keyname");
    my_canvas_widgetbehavior.w_getrectfn = my_canvas_getrect;
    my_canvas_widgetbehavior.w_displacefn = my_canvas_displace;
    my_canvas_widgetbehavior.w_selectfn = my_canvas_select;
    my_canvas_widgetbehavior.w_activatefn = NULL;
    my_canvas_widgetbehavior.w_deletefn = my_canvas_delete;
    my_canvas_widgetbehavior.w_visfn = my_canvas_vis;
#if (PD_VERSION_MINOR > 31)
    my_canvas_widgetbehavior.w_clickfn = NULL;
    my_canvas_widgetbehavior.w_propertiesfn = my_canvas_properties;
#endif
    my_canvas_widgetbehavior.w_savefn = my_canvas_save;
    class_setwidget(my_canvas_class, &my_canvas_widgetbehavior);
    class_sethelpsymbol(my_canvas_class, gensym("iemhelp/help-my_canvas"));
}
