/* ------------- radiobut     gui-radiobutton ---------------------- */

t_widgetbehavior radiobut_widgetbehavior;
static t_class *radiobut_class;

typedef struct _radiobut
{
    t_object x_obj;
    t_glist *x_glist;
    int      x_size;
    int      x_ldx;
    int      x_ldy;
    char     x_font[16];
    int      x_fontsize;
    int      x_on;
    int      x_on_old;
    int      x_change;
    int      x_number;
    int      x_fcol;
    int      x_bcol;
    int      x_lcol;
    int      x_loadinit;
    int      x_snd_able;
    int      x_rcv_able;
    int      x_selected;
    int      x_shiftdown;
    t_symbol *x_snd;
    t_symbol *x_rcv;
    t_symbol *x_lab;
    t_atom   x_at[2];
} t_radiobut;

/* widget helper functions */

void radiobut_update(t_radiobut *x, t_glist *glist)
{
    if(glist_isvisible(glist))
    {
	t_canvas *canvas=glist_getcanvas(glist);

	sys_vgui(".x%x.c itemconfigure %xBUT%d -fill %s -outline %s\n", canvas, x, x->x_on_old,
		 iem_gui_color_str[x->x_bcol], iem_gui_color_str[x->x_bcol]);
	sys_vgui(".x%x.c itemconfigure %xBUT%d -fill %s -outline %s\n", canvas, x, x->x_on,
		 iem_gui_color_str[x->x_fcol], iem_gui_color_str[x->x_fcol]);
    }
}

void radiobut_draw(t_radiobut *x, t_glist *glist, int firsttime)
{
    t_canvas *canvas=glist_getcanvas(glist);
    int n=x->x_number, i, dx=x->x_size, s4=dx/4;
    int yy11=x->x_obj.te_ypos, yy12=yy11+dx;
    int yy21=yy11+s4, yy22=yy12-s4;
    int xx11b=x->x_obj.te_xpos, xx11=x->x_obj.te_xpos, xx21=xx11b+s4;
    int xx22=xx11b+dx-s4;

    if(firsttime)
    {
	for(i=0; i<n; i++)
	{
	    sys_vgui(".x%x.c create rectangle %d %d %d %d -fill %s -tags %xBASE%d\n",
		     canvas, xx11, yy11, xx11+dx, yy12,
		     iem_gui_color_str[x->x_bcol], x, i);
	    sys_vgui(".x%x.c create rectangle %d %d %d %d -fill %s -outline %s -tags %xBUT%d\n",
		     canvas, xx21, yy21, xx22, yy22,
		     iem_gui_color_str[(x->x_on==i)?x->x_fcol:x->x_bcol],
		     iem_gui_color_str[(x->x_on==i)?x->x_fcol:x->x_bcol], x, i);
	    xx11 += dx;
	    xx21 += dx;
	    xx22 += dx;
	}
	if(!strcmp(x->x_lab->s_name, "empty"))
	    sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, xx11b+x->x_ldx, yy11+x->x_ldy,
		     "", x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
	else
	    sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, xx11b+x->x_ldx, yy11+x->x_ldy,
		     x->x_lab->s_name, x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
	sys_vgui(".x%x.c create rectangle %d %d %d %d -tags %xOUT%d\n",
		 canvas, xx11b, yy12-1, xx11b + IOWIDTH, yy12, x, 0);
	sys_vgui(".x%x.c create rectangle %d %d %d %d -tags %xIN%d\n",
		 canvas, xx11b, yy11, xx11b + IOWIDTH, yy11+1, x, 0);
    }
    else
    {
	xx11 = xx11b;
	xx21=xx11b+s4;
	xx22=xx11b+dx-s4;
	for(i=0; i<n; i++)
	{
	    sys_vgui(".x%x.c coords %xBASE%d %d %d %d %d\n",
		     canvas, x, i, xx11, yy11, xx11+dx, yy12);
	    sys_vgui(".x%x.c coords %xBUT%d %d %d %d %d\n",
		     canvas, x, i, xx21, yy21, xx22, yy22);
	    xx11 += dx;
	    xx21 += dx;
	    xx22 += dx;
	}
	sys_vgui(".x%x.c coords %xLABEL %d %d\n",
		 canvas, x, xx11b+x->x_ldx, yy11+x->x_ldy);
	sys_vgui(".x%x.c coords %xOUT%d %d %d %d %d\n",
		 canvas, x, 0, xx11b, yy12-1, xx11b + IOWIDTH, yy12);
	sys_vgui(".x%x.c coords %xIN%d %d %d %d %d\n",
		 canvas, x, 0, xx11b, yy11, xx11b + IOWIDTH, yy11+1);
    }
}

void radiobut_erase(t_radiobut* x, t_glist* glist)
{
    t_canvas *canvas=glist_getcanvas(glist);
    int n=x->x_number, i;

    for(i=0; i<n; i++)
    {
	sys_vgui(".x%x.c delete %xBASE%d\n", canvas, x, i);
	sys_vgui(".x%x.c delete %xBUT%d\n", canvas, x, i);
    }
    sys_vgui(".x%x.c delete %xLABEL\n", canvas, x);
    sys_vgui(".x%x.c delete %xIN%d\n", canvas, x, 0);
    sys_vgui(".x%x.c delete %xOUT%d\n", canvas, x, 0);
}

/* ------------------------ bg widgetbehaviour----------------------------- */

static void radiobut_getrect(t_gobj *z, t_glist *owner, int *xp1, int *yp1, int *xp2, int *yp2)
{
    t_radiobut *x = (t_radiobut *)z;

    *xp1 = x->x_obj.te_xpos;
    *yp1 = x->x_obj.te_ypos;
    *xp2 = x->x_obj.te_xpos + x->x_size*x->x_number;
    *yp2 = x->x_obj.te_ypos + x->x_size;
}

static void radiobut_displace(t_gobj *z, t_glist *glist, int dx, int dy)
{
    t_radiobut *x = (t_radiobut *)z;

    x->x_obj.te_xpos += dx;
    x->x_obj.te_ypos += dy;
    radiobut_draw(x, glist, 0);
    canvas_fixlinesfor(glist_getcanvas(glist), (t_text *)x);
}

static void radiobut_select(t_gobj *z, t_glist *glist, int selected)
{
    t_radiobut *x = (t_radiobut *)z;
    t_canvas *canvas=glist_getcanvas(glist);
    int n=x->x_number, i;

    x->x_selected = selected;
    if(selected)
    {
	pd_bind(&x->x_obj.ob_pd, iem_gui_key_sym);
	for(i=0; i<n; i++)
	{
	    sys_vgui(".x%x.c itemconfigure %xBASE%d -outline %s\n", canvas, x, i,
		     IEM_GUI_COLOR_SELECTED);
	}
	sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
    }
    else
    {
	pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
	for(i=0; i<n; i++)
	{
	    sys_vgui(".x%x.c itemconfigure %xBASE%d -outline %s\n", canvas, x, i,
		     IEM_GUI_COLOR_NORMAL);
	}
	sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x,
		 iem_gui_color_str[x->x_lcol]);
    }
}

static void radiobut_delete(t_gobj *z, t_glist *glist)
{
    t_radiobut *x = (t_radiobut *)z;

    canvas_deletelinesfor(glist_getcanvas(glist), (t_text *)z);
}

static void radiobut_vis(t_gobj *z, t_glist *glist, int vis)
{
    t_radiobut *x = (t_radiobut *)z;

    if(vis)
	radiobut_draw(x, glist, 1);
    else
	radiobut_erase(x, glist);
}

static void radiobut_save(t_gobj *z, t_binbuf *b)
{
    t_radiobut *x = (t_radiobut *)z;

    binbuf_addv(b, "ssiisiiiisssiiiiiiii", gensym("#X"),gensym("obj"),
		(t_int)x->x_obj.te_xpos, (t_int)x->x_obj.te_ypos,
		gensym("radiobut"), x->x_size,
		x->x_change, x->x_loadinit, x->x_number,
		x->x_snd, x->x_rcv, x->x_lab,
		x->x_ldx, x->x_ldy,
		(int)(x->x_font[0]-'a'+1)/8, x->x_fontsize,
		x->x_bcol, x->x_fcol, x->x_lcol, x->x_on);
    binbuf_addv(b, ";");
}

static void radiobut_properties(t_gobj *z, t_glist *owner)
{
    t_radiobut *x = (t_radiobut *)z;
    char buf[600];
    /*new-beg*/
    str_xch_dollar2raute(x->x_snd);
    str_xch_dollar2raute(x->x_rcv);
    /*new-end*/
    sprintf(buf, "pdtk_iemgui_dialog %%s RADIO-BUTTON \
	    ----------dimensions(pix):----------- %g %g size: 0 0 empty \
	    empty 0.0 empty 0.0 empty %g \
	    %g new-only new&old %g %g \
	    %s %s \
	    %s %g %g \
	    %g %g \
	    %g %s \
	    %g %s \
	    %g %s\n",
	    (float)x->x_size, (float)IEM_GUI_MINSIZE,
	    0.0,/*no_schedule*/
	    (float)x->x_change, (float)x->x_loadinit, (float)x->x_number,
	    x->x_snd->s_name, x->x_rcv->s_name,
	    x->x_lab->s_name, (float)x->x_ldx, (float)x->x_ldy,
	    (float)((int)(x->x_font[0]-'a'+1)/8), (float)x->x_fontsize,
	    (float)x->x_bcol, iem_gui_color_str[x->x_bcol],
	    (float)x->x_fcol, iem_gui_color_str[x->x_fcol],
	    (float)x->x_lcol, iem_gui_color_str[x->x_lcol]);
    gfxstub_new(&x->x_obj.ob_pd, x, buf);
    /*new-beg*/
    str_xch_raute2dollar(x->x_snd);
    str_xch_raute2dollar(x->x_rcv);
    /*new-end*/
}

static void radiobut_dialog(t_radiobut *x, t_symbol *s, int argc, t_atom *argv)
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);
    int a = (int)atom_getintarg(0, argc, argv);
    int chg = (int)atom_getintarg(4, argc, argv);
    int init = (int)atom_getintarg(5, argc, argv);
    int num = (int)atom_getintarg(6, argc, argv);
    t_symbol *snd = atom_getsymbolarg(7, argc, argv);
    t_symbol *rcv = atom_getsymbolarg(8, argc, argv);
    t_symbol *lab = atom_getsymbolarg(9, argc, argv);
    int ldx = (int)atom_getintarg(10, argc, argv);
    int ldy = (int)atom_getintarg(11, argc, argv);
    int f = (int)atom_getintarg(12, argc, argv);
    int fs = (int)atom_getintarg(13, argc, argv);
    int bcol = (int)atom_getintarg(14, argc, argv);
    int fcol = (int)atom_getintarg(15, argc, argv);
    int lcol = (int)atom_getintarg(16, argc, argv);
    int sndable=1, rcvable=1, i;

    if(init != 0) init = 1;
    x->x_loadinit = init;
    if(chg != 0) chg = 1;
    x->x_change = chg;
    /*new-beg*/
    str_xch_raute2dollar(snd);
    str_xch_raute2dollar(rcv);
    /*new-end*/
    if(!strcmp(snd->s_name, "empty")) sndable = 0;
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(rcv->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
	    x->x_rcv = rcv;
	    pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_snd = snd;
    x->x_snd_able = sndable;
    x->x_rcv_able = rcvable;
    x->x_size = iem_gui_clip_size(a);
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_fcol = iem_gui_modulo_color(fcol);
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    if(fs < 4)
        fs = 4;
    x->x_fontsize = fs;

    if(x->x_number != num)
    {
	radiobut_erase(x, x->x_glist);
	x->x_number = num;
	if(x->x_on >= x->x_number)
	{
	    x->x_on = x->x_number - 1;
            x->x_on_old = x->x_on;
	}
	radiobut_draw(x, x->x_glist, 1);
    }
    else
    {
	if(!strcmp(x->x_lab->s_name, "empty"))
	    sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		     canvas, x, x->x_font, x->x_fontsize,
		     x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol], "");
	else
	    sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		     canvas, x, x->x_font, x->x_fontsize,
		     x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol],
		     x->x_lab->s_name);
	for(i=0; i<num; i++)
	{
	    sys_vgui(".x%x.c itemconfigure %xBASE%d -fill %s\n", canvas, x, i,
		     iem_gui_color_str[x->x_bcol]);
	    sys_vgui(".x%x.c itemconfigure %xBUT%d -fill %s -outline %s\n", canvas, x, i,
		     iem_gui_color_str[(x->x_on==i)?x->x_fcol:x->x_bcol],
		     iem_gui_color_str[(x->x_on==i)?x->x_fcol:x->x_bcol]);
	}
	radiobut_draw(x, x->x_glist, 0);
	canvas_fixlinesfor(canvas, (t_text*)x);
    }
}

static void radiobut_set(t_radiobut *x, t_floatarg f)
{
    int i=(int)f;
    int old;

    if(i < 0)
	i = 0;
    if(i >= x->x_number)
	i = x->x_number-1;
    if(x->x_on != x->x_on_old)
    {
	old = x->x_on_old;
	x->x_on_old = x->x_on;
	x->x_on = i;
	radiobut_update(x, x->x_glist);
	x->x_on_old = old;
    }
    else
    {
	x->x_on = i;
	radiobut_update(x, x->x_glist);
    }
}

static void radiobut_float(t_radiobut *x, t_floatarg f)
{
    int i=(int)f;

    if(i < 0)
	i = 0;
    if(i >= x->x_number)
	i = x->x_number-1;

    if((x->x_change)&&(i != x->x_on_old))
    {
	SETFLOAT(x->x_at, (float)x->x_on_old);
	SETFLOAT(x->x_at+1, 0.0);
	outlet_list(x->x_obj.ob_outlet, &s_list, 2, x->x_at);
	if(x->x_snd_able && x->x_snd->s_thing)
	    pd_list(x->x_snd->s_thing, &s_list, 2, x->x_at);
    }
    if(x->x_on != x->x_on_old)
	x->x_on_old = x->x_on;
    x->x_on = i;
    radiobut_update(x, x->x_glist);
    x->x_on_old = x->x_on;
    SETFLOAT(x->x_at, (float)x->x_on);
    SETFLOAT(x->x_at+1, 1.0);
    outlet_list(x->x_obj.ob_outlet, &s_list, 2, x->x_at);
    if(x->x_snd_able && x->x_snd->s_thing)
	pd_list(x->x_snd->s_thing, &s_list, 2, x->x_at);
}

static void radiobut_bang(t_radiobut *x)
{
    if((x->x_change)&&(x->x_on != x->x_on_old))
    {
        SETFLOAT(x->x_at, (float)x->x_on_old);
	SETFLOAT(x->x_at+1, 0.0);
	outlet_list(x->x_obj.ob_outlet, &s_list, 2, x->x_at);
	if(x->x_snd_able && x->x_snd->s_thing)
	    pd_list(x->x_snd->s_thing, &s_list, 2, x->x_at);
    }
    x->x_on_old = x->x_on;
    SETFLOAT(x->x_at, (float)x->x_on);
    SETFLOAT(x->x_at+1, 1.0);
    outlet_list(x->x_obj.ob_outlet, &s_list, 2, x->x_at);
    if(x->x_snd_able && x->x_snd->s_thing)
	pd_list(x->x_snd->s_thing, &s_list, 2, x->x_at);
}

static void radiobut_click(t_radiobut *x, t_floatarg xpos, t_floatarg ypos, t_floatarg shift, t_floatarg ctrl, t_floatarg alt)
{
    int xx = (int)xpos - (int)x->x_obj.te_xpos;

    radiobut_float(x, (float)(xx / x->x_size));
}

#if (PD_VERSION_MINOR > 31)
static int radiobut_newclick(t_gobj *z, struct _glist *glist, int xpix, int ypix, int shift, int alt, int dbl, int doit)
{
    if(doit)
	radiobut_click((t_radiobut *)z, (t_floatarg)xpix, (t_floatarg)ypix, (t_floatarg)shift, 0, (t_floatarg)alt);
    return (1);
}
#endif

static void radiobut_loadbang(t_radiobut *x)
{
    if(!sys_noloadbang && x->x_loadinit)
	radiobut_bang(x);
}

static void radiobut_number(t_radiobut *x, t_floatarg num)
{
    int n=(int)num;

    if(n < 1)
	n = 1;
    if(n > 128)
	n = 128;
    if(n != x->x_number)
    {
	radiobut_erase(x, x->x_glist);
	x->x_number = n;
	if(x->x_on >= x->x_number)
	    x->x_on = x->x_number - 1;
        x->x_on_old = x->x_on;
	radiobut_draw(x, x->x_glist, 1);
    }
}

static void radiobut_size(t_radiobut *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_size = iem_gui_clip_size((int)atom_getintarg(0, ac, av));
    radiobut_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void radiobut_delta(t_radiobut *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_obj.te_xpos += (int)atom_getintarg(0, ac, av);
    x->x_obj.te_ypos += (int)atom_getintarg(1, ac, av);
    radiobut_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void radiobut_pos(t_radiobut *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_obj.te_xpos = (int)atom_getintarg(0, ac, av);
    x->x_obj.te_ypos = (int)atom_getintarg(1, ac, av);
    radiobut_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void radiobut_color(t_radiobut *x, t_symbol *s, int ac, t_atom *av)
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);
    int n=x->x_number, i;

    x->x_bcol = iem_gui_modulo_color((int)atom_getintarg(0, ac, av));
    x->x_fcol = iem_gui_modulo_color((int)atom_getintarg(1, ac, av));
    x->x_lcol = iem_gui_modulo_color((int)atom_getintarg(2, ac, av));
    sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x,
	     x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol]);
    for(i=0; i<n; i++)
    {
	sys_vgui(".x%x.c itemconfigure %xBASE%d -fill %s\n", canvas, x, i,
	     iem_gui_color_str[x->x_bcol]);
	sys_vgui(".x%x.c itemconfigure %xBUT%d -fill %s -outline %s\n", canvas, x, i,
	     iem_gui_color_str[(x->x_on==i)?x->x_fcol:x->x_bcol],
	     iem_gui_color_str[(x->x_on==i)?x->x_fcol:x->x_bcol]);
    }
}

static void radiobut_send(t_radiobut *x, t_symbol *s)
{
    int sndable=1;
    /*new-beg*/
    str_xch_raute2dollar(s);
    /*new-end*/
    if(!strcmp(s->s_name, "empty")) sndable = 0;
    x->x_snd = s;
    x->x_snd_able = sndable;
}

static void radiobut_receive(t_radiobut *x, t_symbol *s)
{
    int rcvable=1;
    /*new-beg*/
    str_xch_raute2dollar(s);
    /*new-end*/
    if(!strcmp(s->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(s->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
	    x->x_rcv = s;
	    pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_rcv_able = rcvable;
}

static void radiobut_label(t_radiobut *x, t_symbol *s)
{
    x->x_lab = s;
    if(!strcmp(s->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n", glist_getcanvas(x->x_glist), x, "");
    else
	sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n", glist_getcanvas(x->x_glist), x, s->s_name);
}

static void radiobut_label_pos(t_radiobut *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_ldx = (int)atom_getintarg(0, ac, av);
    x->x_ldy = (int)atom_getintarg(1, ac, av);
    sys_vgui(".x%x.c coords %xLABEL %d %d\n", glist_getcanvas(x->x_glist), x,
	     x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy);
}

static void radiobut_label_font(t_radiobut *x, t_symbol *s, int ac, t_atom *av)
{
    int f = (int)atom_getintarg(0, ac, av);

    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    f = (int)atom_getintarg(1, ac, av);
    if(f < 4)
        f = 4;
    x->x_fontsize = f;
    sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold}\n",
	     glist_getcanvas(x->x_glist), x, x->x_font, x->x_fontsize);
}

static void radiobut_init(t_radiobut *x, t_floatarg f)
{
    x->x_loadinit = (f==0.0)?0:1;
}

static void radiobut_double_change(t_radiobut *x)
{
    x->x_change = 1;
}

static void radiobut_single_change(t_radiobut *x)
{
    x->x_change = 0;
}

static void radiobut_list(t_radiobut *x, t_symbol *s, int ac, t_atom *av)
{
    if(x->x_selected)
    {
	if((ac != 2)||!IS_A_FLOAT(av,0)||!IS_A_SYMBOL(av,1))
	    goto radiobutlistelse;
	else
	{
	    t_symbol *key = atom_getsymbolarg(1, ac, av);
	    int keydown = atom_getintarg(0, ac, av);

	    if(keydown)
	    {
		int refresh = 1,i,d=1;
		static char buf[20];

		buf[0] = 0;
		if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		    x->x_shiftdown = 1;
		else
		{
		    if(x->x_shiftdown)
			d = 10;

		    if(!strcmp(key->s_name, "Up"))
			x->x_obj.te_ypos -= d;
		    else if(!strcmp(key->s_name, "Down"))
			x->x_obj.te_ypos += d;
		    else if(!strcmp(key->s_name, "Left"))
			x->x_obj.te_xpos -= d;
		    else if(!strcmp(key->s_name, "Right"))
			x->x_obj.te_xpos += d;
		    else
			refresh = 0;
		    if(refresh)
		    {
			radiobut_draw(x, x->x_glist, 0);
			canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
		    }
		}
	    }
	    else
	    {
		if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		    x->x_shiftdown = 0;
	    }
	}
	return;
    }
radiobutlistelse:
    if(IS_A_FLOAT(av,0))
	radiobut_float(x, atom_getfloatarg(0, ac, av));
}

static void *radiobut_new(t_symbol *s, int argc, t_atom *argv)
{
    t_radiobut *x = (t_radiobut *)pd_new(radiobut_class);
    int bcol=IEM_GUI_COLNR_WHITE, fcol=IEM_GUI_COLNR_BLACK, lcol=IEM_GUI_COLNR_BLACK;
    int a=IEM_GUI_DEFAULTSIZE;
    int init=0, ldx=8, ldy=-8, on=0, f=0, fs=10;
    int sndable=1, rcvable=1, chg=1, num=8;
    t_symbol *snd = gensym("empty"), *rcv = gensym("empty"), *lab = gensym("empty");

    if((argc == 15)&&IS_A_FLOAT(argv,0)&&IS_A_FLOAT(argv,1)&&IS_A_FLOAT(argv,2)
       &&IS_A_FLOAT(argv,3)&&IS_A_SYMBOL(argv,4)&&IS_A_SYMBOL(argv,5)
       &&IS_A_SYMBOL(argv,6)&&IS_A_FLOAT(argv,7)&&IS_A_FLOAT(argv,8)
       &&IS_A_FLOAT(argv,9)&&IS_A_FLOAT(argv,10)&&IS_A_FLOAT(argv,11)
       &&IS_A_FLOAT(argv,12)&&IS_A_FLOAT(argv,13)&&IS_A_FLOAT(argv,14))
    {
	a = (int)atom_getintarg(0, argc, argv);
	chg = (int)atom_getintarg(1, argc, argv);
	init = (int)atom_getintarg(2, argc, argv);
	num = (int)atom_getintarg(3, argc, argv);
	snd = atom_getsymbolarg(4, argc, argv);
	rcv = atom_getsymbolarg(5, argc, argv);
	lab = atom_getsymbolarg(6, argc, argv);
	ldx = (int)atom_getintarg(7, argc, argv);
	ldy = (int)atom_getintarg(8, argc, argv);
	f = (int)atom_getintarg(9, argc, argv);
	fs = (int)atom_getintarg(10, argc, argv);
	bcol = (int)atom_getintarg(11, argc, argv);
	fcol = (int)atom_getintarg(12, argc, argv);
	lcol = (int)atom_getintarg(13, argc, argv);
	on = (int)atom_getintarg(14, argc, argv);
    }
    if(init != 0) init = 1;
    x->x_loadinit = init;
    if(num < 1)
	num = 1;
    if(num > 128)
	num = 128;
    x->x_number = num;
    if(on < 0)
	on = 0;
    if(on >= x->x_number)
	on = x->x_number - 1;
    if(x->x_loadinit)
	x->x_on = on;
    else
        x->x_on = 0;
    x->x_on_old = x->x_on;
    x->x_change = (chg==0)?0:1;
    x->x_glist = (t_glist *)canvas_getcurrent();
    if(!strcmp(snd->s_name, "empty")) sndable = 0;
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable) pd_bind(&x->x_obj.ob_pd, rcv);
    x->x_snd_able = sndable;
    x->x_rcv_able = rcvable;
    x->x_snd = snd;
    x->x_rcv = rcv;
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    if(fs < 4)
        fs = 4;
    x->x_fontsize = fs;
    x->x_size = iem_gui_clip_size(a);
    x->x_fcol = iem_gui_modulo_color(fcol);
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_selected = 0;
    x->x_shiftdown = 0;
    outlet_new(&x->x_obj, &s_list);
    return (x);
}

static void radiobut_ff(t_radiobut *x)
{
    if(x->x_selected)
	pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
    if(x->x_rcv_able)
	pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
}

void radiobut_setup(void)
{
    radiobut_class = class_new(gensym("rdb"), (t_newmethod)radiobut_new,
			       (t_method)radiobut_ff, sizeof(t_radiobut), 0, A_GIMME, 0);
    class_addcreator((t_newmethod)radiobut_new, gensym("radiobut"), A_GIMME, 0);
    class_addcreator((t_newmethod)radiobut_new, gensym("radiobutton"), A_GIMME, 0);
    class_addbang(radiobut_class, radiobut_bang);
    class_addfloat(radiobut_class, radiobut_float);
    class_addlist(radiobut_class, radiobut_list);
    class_addmethod(radiobut_class, (t_method)radiobut_click, gensym("click"),
		    A_FLOAT, A_FLOAT, A_FLOAT, A_FLOAT, A_FLOAT, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_dialog, gensym("dialog"),
		    A_GIMME, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_loadbang, gensym("loadbang"), 0);
    class_addmethod(radiobut_class, (t_method)radiobut_set, gensym("set"), A_FLOAT, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_size, gensym("size"), A_GIMME, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_delta, gensym("delta"), A_GIMME, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_pos, gensym("pos"), A_GIMME, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_color, gensym("color"), A_GIMME, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_send, gensym("send"), A_DEFSYM, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_receive, gensym("receive"), A_DEFSYM, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_label, gensym("label"), A_DEFSYM, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_label_pos, gensym("label_pos"), A_GIMME, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_label_font, gensym("label_font"), A_GIMME, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_init, gensym("init"), A_FLOAT, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_number, gensym("number"), A_FLOAT, 0);
    class_addmethod(radiobut_class, (t_method)radiobut_single_change, gensym("single_change"), 0);
    class_addmethod(radiobut_class, (t_method)radiobut_double_change, gensym("double_change"), 0);
    if(!iem_gui_key_sym)
	iem_gui_key_sym = gensym("#keyname");
    radiobut_widgetbehavior.w_getrectfn = radiobut_getrect;
    radiobut_widgetbehavior.w_displacefn = radiobut_displace;
    radiobut_widgetbehavior.w_selectfn = radiobut_select;
    radiobut_widgetbehavior.w_activatefn = NULL;
    radiobut_widgetbehavior.w_deletefn = radiobut_delete;
    radiobut_widgetbehavior.w_visfn = radiobut_vis;
#if (PD_VERSION_MINOR > 31)
    radiobut_widgetbehavior.w_clickfn = radiobut_newclick;
    radiobut_widgetbehavior.w_propertiesfn = radiobut_properties;
#endif
    radiobut_widgetbehavior.w_savefn = radiobut_save;
    class_setwidget(radiobut_class, &radiobut_widgetbehavior);
    class_sethelpsymbol(radiobut_class, gensym("iemhelp/help-radiobut"));
}
