/* --------------- toggle     gui-toggle ------------------------- */

t_widgetbehavior toggle_widgetbehavior;
static t_class *toggle_class;

typedef struct _toggle
{
     t_object x_obj;
     t_glist *x_glist;
     int      x_size;
     int      x_ldx;
     int      x_ldy;
     char     x_font[16];
     int      x_fontsize;
     float    x_on;
     float    x_nonzero;
     int      x_fcol;
     int      x_bcol;
     int      x_lcol;
     int      x_loadinit;
     int      x_snd_able;
     int      x_rcv_able;
     int      x_selected;
     int      x_shiftdown;
     t_symbol *x_snd;
     t_symbol *x_rcv;
     t_symbol *x_lab;
} t_toggle;

/* widget helper functions */

void toggle_update(t_toggle *x, t_glist *glist)
{
    if(glist_isvisible(glist))
    {
        t_canvas *canvas=glist_getcanvas(glist);

        sys_vgui(".x%x.c itemconfigure %xX1 -fill %s\n", canvas, x,
		 iem_gui_color_str[(x->x_on!=0.0)?x->x_fcol:x->x_bcol]);
	sys_vgui(".x%x.c itemconfigure %xX2 -fill %s\n", canvas, x,
		 iem_gui_color_str[(x->x_on!=0.0)?x->x_fcol:x->x_bcol]);
    }
}

void toggle_draw(t_toggle *x, t_glist *glist, int firsttime)
{
    t_canvas *canvas=glist_getcanvas(glist);
    int w=1, xx=x->x_obj.te_xpos, yy=x->x_obj.te_ypos;

    if(x->x_size >= 30)
	w = 2;
    if(x->x_size >= 60)
	w = 3;
    if(firsttime)
    {
        sys_vgui(".x%x.c create rectangle %d %d %d %d -fill %s -tags %xBASE\n",
		 canvas, xx, yy, xx + x->x_size, yy + x->x_size,
		 iem_gui_color_str[x->x_bcol], x);
	sys_vgui(".x%x.c create line %d %d %d %d -width %d -fill %s -tags %xX1\n",
		 canvas, xx+w, yy+w, xx + x->x_size-w, yy + x->x_size-w, w,
		 iem_gui_color_str[(x->x_on!=0.0)?x->x_fcol:x->x_bcol], x);
	sys_vgui(".x%x.c create line %d %d %d %d -width %d -fill %s -tags %xX2\n",
		 canvas, xx+w, yy + x->x_size-w, xx + x->x_size-w, yy+w, w,
		 iem_gui_color_str[(x->x_on!=0.0)?x->x_fcol:x->x_bcol], x);
        if(!strcmp(x->x_lab->s_name, "empty"))
	    sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy,
		     "", x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
        else
            sys_vgui(".x%x.c create text %d %d -text {%s} -anchor w \
		     -font {%s %d bold} -fill %s -tags %xLABEL\n",
		     canvas, x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy,
		     x->x_lab->s_name, x->x_font, x->x_fontsize,
		     iem_gui_color_str[x->x_lcol], x);
        sys_vgui(".x%x.c create rectangle %d %d %d %d -tags %xOUT%d\n",
		 canvas, xx, yy + x->x_size-1, xx + IOWIDTH, yy + x->x_size, x, 0);
	sys_vgui(".x%x.c create rectangle %d %d %d %d -tags %xIN%d\n",
		 canvas, xx, yy, xx + IOWIDTH, yy+1, x, 0);
    }
    else
    {
        sys_vgui(".x%x.c coords %xBASE %d %d %d %d\n",
		 canvas, x, xx, yy, xx + x->x_size, yy + x->x_size);
        sys_vgui(".x%x.c itemconfigure %xX1 -width %d\n", canvas, x, w);
	sys_vgui(".x%x.c coords %xX1 %d %d %d %d\n",
		 canvas, x, xx+w, yy+w, xx + x->x_size-w, yy + x->x_size-w);
        sys_vgui(".x%x.c itemconfigure %xX2 -width %d\n", canvas, x, w);
	sys_vgui(".x%x.c coords %xX2 %d %d %d %d\n",
		 canvas, x, xx+w, yy + x->x_size-w, xx + x->x_size-w, yy+w);
        sys_vgui(".x%x.c coords %xLABEL %d %d\n",
		 canvas, x, xx+x->x_ldx, yy+x->x_ldy);
        sys_vgui(".x%x.c coords %xOUT%d %d %d %d %d\n",
		 canvas, x, 0, xx, yy + x->x_size-1, xx + IOWIDTH, yy + x->x_size);
        sys_vgui(".x%x.c coords %xIN%d %d %d %d %d\n",
		 canvas, x, 0, xx, yy, xx + IOWIDTH, yy+1);
    }
}

void toggle_erase(t_toggle* x, t_glist* glist)
{
    t_canvas *canvas=glist_getcanvas(glist);

    sys_vgui(".x%x.c delete %xBASE\n", canvas, x);
    sys_vgui(".x%x.c delete %xX1\n", canvas, x);
    sys_vgui(".x%x.c delete %xX2\n", canvas, x);
    sys_vgui(".x%x.c delete %xLABEL\n", canvas, x);
    sys_vgui(".x%x.c delete %xIN%d\n", canvas, x, 0);
    sys_vgui(".x%x.c delete %xOUT%d\n", canvas, x, 0);
}

/* ------------------------ bg widgetbehaviour----------------------------- */

static void toggle_getrect(t_gobj *z, t_glist *owner, int *xp1, int *yp1, int *xp2, int *yp2)
{
    t_toggle *x = (t_toggle *)z;

    *xp1 = x->x_obj.te_xpos;
    *yp1 = x->x_obj.te_ypos;
    *xp2 = x->x_obj.te_xpos + x->x_size;
    *yp2 = x->x_obj.te_ypos + x->x_size;
}

static void toggle_displace(t_gobj *z, t_glist *glist, int dx, int dy)
{
    t_toggle *x = (t_toggle *)z;

    x->x_obj.te_xpos += dx;
    x->x_obj.te_ypos += dy;
    toggle_draw(x, glist, 0);
    canvas_fixlinesfor(glist_getcanvas(glist), (t_text *)x);
}

static void toggle_select(t_gobj *z, t_glist *glist, int selected)
{
    t_toggle *x = (t_toggle *)z;
    t_canvas *canvas=glist_getcanvas(glist);

    x->x_selected = selected;
    if(selected)
    {
        pd_bind(&x->x_obj.ob_pd, iem_gui_key_sym);
        sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
        sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x, IEM_GUI_COLOR_SELECTED);
    }
    else
    {
        pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
        sys_vgui(".x%x.c itemconfigure %xBASE -outline %s\n", canvas, x, IEM_GUI_COLOR_NORMAL);
	sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas, x, iem_gui_color_str[x->x_lcol]);
    }
}

static void toggle_delete(t_gobj *z, t_glist *glist)
{
    t_toggle *x = (t_toggle *)z;

    canvas_deletelinesfor(glist_getcanvas(glist), (t_text *)z);
}

static void toggle_vis(t_gobj *z, t_glist *glist, int vis)
{
    t_toggle *x = (t_toggle *)z;

    if(vis)
	toggle_draw(x, glist, 1);
    else
	toggle_erase(x, glist);
}

static void toggle_save(t_gobj *z, t_binbuf *b)
{
    t_toggle *x = (t_toggle *)z;

    binbuf_addv(b, "ssiisiisssiiiiiiiff", gensym("#X"),gensym("obj"),
		(t_int)x->x_obj.te_xpos, (t_int)x->x_obj.te_ypos,
		gensym("toggle"), x->x_size,
		x->x_loadinit,
                x->x_snd, x->x_rcv, x->x_lab,
		x->x_ldx, x->x_ldy,
                (int)(x->x_font[0]-'a'+1)/8, x->x_fontsize,
		x->x_bcol, x->x_fcol, x->x_lcol, x->x_on, x->x_nonzero);
    binbuf_addv(b, ";");
}

static void toggle_properties(t_gobj *z, t_glist *owner)
{
    t_toggle *x = (t_toggle *)z;
    char buf[600];
    /*new-beg*/
    str_xch_dollar2raute(x->x_snd);
    str_xch_dollar2raute(x->x_rcv);
    /*new-end*/
    sprintf(buf, "pdtk_iemgui_dialog %%s TOGGLE \
	    ----------dimensions(pix):----------- %g %g size: 0 0 empty \
            -----------non-zero-value:----------- %g value: 0.0 empty %g \
	    -1 lin log %g %g \
	    %s %s \
	    %s %g %g \
            %g %g \
	    %g %s \
            %g %s \
	    %g %s\n",
	    (float)x->x_size, (float)IEM_GUI_MINSIZE,
	    x->x_nonzero, 1.0,/*non_zero-schedule*/
	    (float)x->x_loadinit, -1.0,/*no multi*/
	    x->x_snd->s_name, x->x_rcv->s_name,
	    x->x_lab->s_name, (float)x->x_ldx, (float)x->x_ldy,
            (float)((int)(x->x_font[0]-'a'+1)/8), (float)x->x_fontsize,
            (float)x->x_bcol, iem_gui_color_str[x->x_bcol],
	    (float)x->x_fcol, iem_gui_color_str[x->x_fcol],
	    (float)x->x_lcol, iem_gui_color_str[x->x_lcol]);
    gfxstub_new(&x->x_obj.ob_pd, x, buf);
    /*new-beg*/
    str_xch_raute2dollar(x->x_snd);
    str_xch_raute2dollar(x->x_rcv);
    /*new-end*/
}

static void toggle_bang(t_toggle *x)
{
    x->x_on = (x->x_on==0.0)?x->x_nonzero:0.0;
    toggle_update(x, x->x_glist);
    outlet_float(x->x_obj.ob_outlet, x->x_on);
    if(x->x_snd_able && x->x_snd->s_thing)
	pd_float(x->x_snd->s_thing, x->x_on);
}

static void toggle_dialog(t_toggle *x, t_symbol *s, int argc, t_atom *argv)
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);
    int a = (int)atom_getintarg(0, argc, argv);
    float nonzero = (float)atom_getfloatarg(2, argc, argv);
    int init = (int)atom_getintarg(5, argc, argv);
    t_symbol *snd = atom_getsymbolarg(7, argc, argv);
    t_symbol *rcv = atom_getsymbolarg(8, argc, argv);
    t_symbol *lab = atom_getsymbolarg(9, argc, argv);
    int ldx = (int)atom_getintarg(10, argc, argv);
    int ldy = (int)atom_getintarg(11, argc, argv);
    int f = (int)atom_getintarg(12, argc, argv);
    int fs = (int)atom_getintarg(13, argc, argv);
    int bcol = (int)atom_getintarg(14, argc, argv);
    int fcol = (int)atom_getintarg(15, argc, argv);
    int lcol = (int)atom_getintarg(16, argc, argv);
    int sndable=1, rcvable=1;

    if(nonzero == 0.0)
	nonzero = 1.0;
    x->x_nonzero = nonzero;
    if(x->x_on != 0.0)
        x->x_on = x->x_nonzero;
    if(init != 0) init = 1;
    x->x_loadinit = init;
    /*new-beg*/
    str_xch_raute2dollar(snd);
    str_xch_raute2dollar(rcv);
    /*new-end*/
    if(!strcmp(snd->s_name, "empty")) sndable = 0;
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(rcv->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
            x->x_rcv = rcv;
            pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_snd = snd;
    x->x_snd_able = sndable;
    x->x_rcv_able = rcvable;
    x->x_size = iem_gui_clip_size(a);
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_fcol = iem_gui_modulo_color(fcol);
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    if(fs < 4)
        fs = 4;
    x->x_fontsize = fs;

    if(!strcmp(x->x_lab->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol], "");
    else
	sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold} -fill %s -text {%s} \n",
		 canvas, x, x->x_font, x->x_fontsize,
		 x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol],
		 x->x_lab->s_name);
    sys_vgui(".x%x.c itemconfigure %xBASE -fill %s\n", canvas, x,
	         iem_gui_color_str[x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xX1 -fill %s\n", canvas, x,
	     iem_gui_color_str[x->x_on?x->x_fcol:x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xX2 -fill %s\n", canvas, x,
	         iem_gui_color_str[x->x_on?x->x_fcol:x->x_bcol]);
    toggle_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(canvas, (t_text*)x);
}

static void toggle_click(t_toggle *x, t_floatarg xpos, t_floatarg ypos, t_floatarg shift, t_floatarg ctrl, t_floatarg alt)
{
    toggle_bang(x);
}

#if (PD_VERSION_MINOR > 31)
static int toggle_newclick(t_gobj *z, struct _glist *glist, int xpix, int ypix, int shift, int alt, int dbl, int doit)
{
    if(doit)
	toggle_click((t_toggle *)z, (t_floatarg)xpix, (t_floatarg)ypix, (t_floatarg)shift, 0, (t_floatarg)alt);
    return (1);
}
#endif

static void toggle_set(t_toggle *x, t_floatarg f)
{
    x->x_on = f;
    if(f != 0.0)
        x->x_nonzero = f;
    toggle_update(x, x->x_glist);
}

static void toggle_float(t_toggle *x, t_floatarg f)
{
    toggle_set(x, f);
    outlet_float(x->x_obj.ob_outlet, x->x_on);
    if(x->x_snd_able && x->x_snd->s_thing)
	pd_float(x->x_snd->s_thing, x->x_on);
}

static void toggle_loadbang(t_toggle *x)
{
    if(!sys_noloadbang && x->x_loadinit)
        toggle_float(x, (float)x->x_on);
}

static void toggle_size(t_toggle *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_size = iem_gui_clip_size((int)atom_getintarg(0, ac, av));
    toggle_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void toggle_delta(t_toggle *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_obj.te_xpos += (int)atom_getintarg(0, ac, av);
    x->x_obj.te_ypos += (int)atom_getintarg(1, ac, av);
    toggle_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void toggle_pos(t_toggle *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_obj.te_xpos = (int)atom_getintarg(0, ac, av);
    x->x_obj.te_ypos = (int)atom_getintarg(1, ac, av);
    toggle_draw(x, x->x_glist, 0);
    canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
}

static void toggle_color(t_toggle *x, t_symbol *s, int ac, t_atom *av)
{
    t_canvas *canvas=glist_getcanvas(x->x_glist);

    x->x_bcol = iem_gui_modulo_color((int)atom_getintarg(0, ac, av));
    x->x_fcol = iem_gui_modulo_color((int)atom_getintarg(1, ac, av));
    x->x_lcol = iem_gui_modulo_color((int)atom_getintarg(2, ac, av));
    sys_vgui(".x%x.c itemconfigure %xLABEL -fill %s\n", canvas,
	     x, x->x_selected?IEM_GUI_COLOR_SELECTED:iem_gui_color_str[x->x_lcol]);
    sys_vgui(".x%x.c itemconfigure %xBASE -fill %s\n", canvas,
	     x, iem_gui_color_str[x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xX1 -fill %s\n", canvas,
	     x, iem_gui_color_str[x->x_on?x->x_fcol:x->x_bcol]);
    sys_vgui(".x%x.c itemconfigure %xX2 -fill %s\n", canvas,
	     x, iem_gui_color_str[x->x_on?x->x_fcol:x->x_bcol]);
}

static void toggle_send(t_toggle *x, t_symbol *s)
{
    int sndable=1;
    /*new-beg*/
    str_xch_raute2dollar(s);
    /*new-end*/
    if(!strcmp(s->s_name, "empty")) sndable = 0;
    x->x_snd = s;
    x->x_snd_able = sndable;
}

static void toggle_receive(t_toggle *x, t_symbol *s)
{
    int rcvable=1;
    /*new-beg*/
    str_xch_raute2dollar(s);
    /*new-end*/
    if(!strcmp(s->s_name, "empty")) rcvable = 0;
    if(rcvable)
    {
	if(strcmp(s->s_name, x->x_rcv->s_name))
	{
	    if(x->x_rcv_able)
		pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
            x->x_rcv = s;
            pd_bind(&x->x_obj.ob_pd, x->x_rcv);
	}
    }
    x->x_rcv_able = rcvable;
}

static void toggle_label(t_toggle *x, t_symbol *s)
{
    x->x_lab = s;
    if(!strcmp(s->s_name, "empty"))
	sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n", glist_getcanvas(x->x_glist), x, "");
    else
        sys_vgui(".x%x.c itemconfigure %xLABEL -text {%s} \n", glist_getcanvas(x->x_glist), x, s->s_name);
}

static void toggle_label_font(t_toggle *x, t_symbol *s, int ac, t_atom *av)
{
    int f = (int)atom_getintarg(0, ac, av);

    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    f = (int)atom_getintarg(1, ac, av);
    if(f < 4)
        f = 4;
    x->x_fontsize = f;
    sys_vgui(".x%x.c itemconfigure %xLABEL -font {%s %d bold}\n",
	     glist_getcanvas(x->x_glist), x, x->x_font, x->x_fontsize);
}

static void toggle_label_pos(t_toggle *x, t_symbol *s, int ac, t_atom *av)
{
    x->x_ldx = (int)atom_getintarg(0, ac, av);
    x->x_ldy = (int)atom_getintarg(1, ac, av);
    sys_vgui(".x%x.c coords %xLABEL %d %d\n", glist_getcanvas(x->x_glist), x,
	     x->x_obj.te_xpos+x->x_ldx, x->x_obj.te_ypos+x->x_ldy);
}

static void toggle_init(t_toggle *x, t_floatarg f)
{
    x->x_loadinit = (f==0.0)?0:1;
}

static void toggle_nonzero(t_toggle *x, t_floatarg f)
{
    if(f != 0.0)
        x->x_nonzero = f;
}

static void toggle_list(t_toggle *x, t_symbol *s, int ac, t_atom *av)
{
    if(x->x_selected)
    {
	if((ac != 2)||!IS_A_FLOAT(av,0)||!IS_A_SYMBOL(av,1))
	    goto togglelistelse;
	else
	{
	    t_symbol *key = atom_getsymbolarg(1, ac, av);
	    int keydown = atom_getintarg(0, ac, av);

	    if(keydown)
	    {
		int refresh = 1,i,d=1;
		static char buf[20];

		buf[0] = 0;
		if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		    x->x_shiftdown = 1;
		else
		{
		    if(x->x_shiftdown)
			d = 10;

		    if(!strcmp(key->s_name, "Up"))
			x->x_obj.te_ypos -= d;
		    else if(!strcmp(key->s_name, "Down"))
			x->x_obj.te_ypos += d;
		    else if(!strcmp(key->s_name, "Left"))
			x->x_obj.te_xpos -= d;
		    else if(!strcmp(key->s_name, "Right"))
			x->x_obj.te_xpos += d;
		    else
			refresh = 0;
		    if(refresh)
		    {
			toggle_draw(x, x->x_glist, 0);
			canvas_fixlinesfor(glist_getcanvas(x->x_glist), (t_text*)x);
		    }
		}
	    }
	    else
	    {
		if(!strcmp(key->s_name, "Shift_L")||!strcmp(key->s_name, "Shift_R"))
		    x->x_shiftdown = 0;
	    }
	}
	return;
    }
togglelistelse:
    if(IS_A_FLOAT(av,0))
	toggle_float(x, atom_getfloatarg(0, ac, av));
}

static void *toggle_new(t_symbol *s, int argc, t_atom *argv)
{
    t_toggle *x = (t_toggle *)pd_new(toggle_class);
    int bcol=IEM_GUI_COLNR_WHITE, fcol=IEM_GUI_COLNR_BLACK, lcol=IEM_GUI_COLNR_BLACK;
    int a=IEM_GUI_DEFAULTSIZE;
    int init=0, ldx=20, ldy=8, f=0, fs=10;
    int sndable=1, rcvable=1;
    float on=0.0, nonzero=1.0;
    t_symbol *snd = gensym("empty"), *rcv = gensym("empty"), *lab = gensym("empty");

    if(((argc == 13)||(argc == 14))&&IS_A_FLOAT(argv,0)
       &&IS_A_FLOAT(argv,1)
       &&IS_A_SYMBOL(argv,2)&&IS_A_SYMBOL(argv,3)
       &&IS_A_SYMBOL(argv,4)&&IS_A_FLOAT(argv,5)&&IS_A_FLOAT(argv,6)
       &&IS_A_FLOAT(argv,7)&&IS_A_FLOAT(argv,8)&&IS_A_FLOAT(argv,9)
       &&IS_A_FLOAT(argv,10)&&IS_A_FLOAT(argv,11)&&IS_A_FLOAT(argv,12))
    {
        a = (int)atom_getintarg(0, argc, argv);
	init = (int)atom_getintarg(1, argc, argv);
        snd = atom_getsymbolarg(2, argc, argv);
	rcv = atom_getsymbolarg(3, argc, argv);
	lab = atom_getsymbolarg(4, argc, argv);
	ldx = (int)atom_getintarg(5, argc, argv);
	ldy = (int)atom_getintarg(6, argc, argv);
        f = (int)atom_getintarg(7, argc, argv);
        fs = (int)atom_getintarg(8, argc, argv);
        bcol = (int)atom_getintarg(9, argc, argv);
	fcol = (int)atom_getintarg(10, argc, argv);
	lcol = (int)atom_getintarg(11, argc, argv);
        on = (float)atom_getfloatarg(12, argc, argv);
    }
    if((argc == 14)&&IS_A_FLOAT(argv,13))
	nonzero = (float)atom_getfloatarg(13, argc, argv);
    if(init != 0) init = 1;
    x->x_loadinit = init;
    x->x_nonzero = (nonzero!=0.0)?nonzero:1.0;
    if(x->x_loadinit)
	x->x_on = (on!=0.0)?nonzero:0.0;
    else
        x->x_on = 0.0;
    x->x_glist = (t_glist *)canvas_getcurrent();
    if(!strcmp(snd->s_name, "empty")) sndable = 0;
    if(!strcmp(rcv->s_name, "empty")) rcvable = 0;
    if(rcvable) pd_bind(&x->x_obj.ob_pd, rcv);
    x->x_snd_able = sndable;
    x->x_rcv_able = rcvable;
    x->x_snd = snd;
    x->x_rcv = rcv;
    x->x_lab = lab;
    x->x_ldx = ldx;
    x->x_ldy = ldy;
    if(f == 1) strcpy(x->x_font, "helvetica");
    else if(f == 2) strcpy(x->x_font, "times");
    else strcpy(x->x_font, "courier");
    if(fs < 4)
        fs = 4;
    x->x_fontsize = fs;
    x->x_size = iem_gui_clip_size(a);
    x->x_fcol = iem_gui_modulo_color(fcol);
    x->x_bcol = iem_gui_modulo_color(bcol);
    x->x_lcol = iem_gui_modulo_color(lcol);
    x->x_selected = 0;
    x->x_shiftdown = 0;
    outlet_new(&x->x_obj, &s_bang);
    return (x);
}

static void toggle_ff(t_toggle *x)
{
    if(x->x_selected)
        pd_unbind(&x->x_obj.ob_pd, iem_gui_key_sym);
    if(x->x_rcv_able)
	pd_unbind(&x->x_obj.ob_pd, x->x_rcv);
}

void toggle_setup(void)
{
    toggle_class = class_new(gensym("tgl"), (t_newmethod)toggle_new,
			     (t_method)toggle_ff, sizeof(t_toggle), 0, A_GIMME, 0);
    class_addcreator((t_newmethod)toggle_new, gensym("toggle"), A_GIMME, 0);
    class_addbang(toggle_class, toggle_bang);
    class_addfloat(toggle_class, toggle_float);
    class_addlist(toggle_class, toggle_list);
    class_addmethod(toggle_class, (t_method)toggle_click, gensym("click"),
		    A_FLOAT, A_FLOAT, A_FLOAT, A_FLOAT, A_FLOAT, 0);
    class_addmethod(toggle_class, (t_method)toggle_dialog, gensym("dialog"),
		    A_GIMME, 0);
    class_addmethod(toggle_class, (t_method)toggle_loadbang, gensym("loadbang"), 0);
    class_addmethod(toggle_class, (t_method)toggle_set, gensym("set"), A_FLOAT, 0);
    class_addmethod(toggle_class, (t_method)toggle_size, gensym("size"), A_GIMME, 0);
    class_addmethod(toggle_class, (t_method)toggle_delta, gensym("delta"), A_GIMME, 0);
    class_addmethod(toggle_class, (t_method)toggle_pos, gensym("pos"), A_GIMME, 0);
    class_addmethod(toggle_class, (t_method)toggle_color, gensym("color"), A_GIMME, 0);
    class_addmethod(toggle_class, (t_method)toggle_send, gensym("send"), A_DEFSYM, 0);
    class_addmethod(toggle_class, (t_method)toggle_receive, gensym("receive"), A_DEFSYM, 0);
    class_addmethod(toggle_class, (t_method)toggle_label, gensym("label"), A_DEFSYM, 0);
    class_addmethod(toggle_class, (t_method)toggle_label_pos, gensym("label_pos"), A_GIMME, 0);
    class_addmethod(toggle_class, (t_method)toggle_label_font, gensym("label_font"), A_GIMME, 0);
    class_addmethod(toggle_class, (t_method)toggle_init, gensym("init"), A_FLOAT, 0);
    class_addmethod(toggle_class, (t_method)toggle_nonzero, gensym("nonzero"), A_FLOAT, 0);
    if(!iem_gui_key_sym)
	iem_gui_key_sym = gensym("#keyname");
    toggle_widgetbehavior.w_getrectfn = toggle_getrect;
    toggle_widgetbehavior.w_displacefn = toggle_displace;
    toggle_widgetbehavior.w_selectfn = toggle_select;
    toggle_widgetbehavior.w_activatefn = NULL;
    toggle_widgetbehavior.w_deletefn = toggle_delete;
    toggle_widgetbehavior.w_visfn = toggle_vis;
#if (PD_VERSION_MINOR > 31)
    toggle_widgetbehavior.w_clickfn = toggle_newclick;
    toggle_widgetbehavior.w_propertiesfn = toggle_properties;
#endif
    toggle_widgetbehavior.w_savefn = toggle_save;
    class_setwidget(toggle_class, &toggle_widgetbehavior);
    class_sethelpsymbol(toggle_class, gensym("iemhelp/help-toggle"));
}
