/* Copyright (c) 1997-1999 Miller Puckette.
* For information on usage and redistribution, and for a DISCLAIMER OF ALL
* WARRANTIES, see the file, "LICENSE.txt," in this distribution.

iemlib written by Thomas Musil (c) IEM KUG Graz Austria 2000 */

#ifdef NT
#pragma warning( disable : 4244 )
#pragma warning( disable : 4305 )
#endif

#ifndef  PD_VERSION_MINOR
#define PD_VERSION_MINOR 32
#endif

#include "m_imp.h"
#include <ctype.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <math.h>
#include "include/iemlib.h"

#ifndef WIN32
#include <sys/signal.h>
#include <unistd.h>
#endif

#include "iemlib2/speedlim.c"
#include "iemlib2/iem_anything.c"
#include "iemlib2/init.c"
#include "iemlib2/prepend.c"
#include "iemlib2/toggle_mess.c"
#include "iemlib2/unsymbol.c"
#include "iemlib2/sigLFO_noise.c"
#include "iemlib2/sigfade.c"
#include "iemlib2/sigm2f.c"


static t_class *iemlliibb22_class;

static void *iemlliibb22_new(void)
{
    t_object *x = (t_object *)pd_new(iemlliibb22_class);
    post("iemlib2 library loaded!");
    return (x);
}

void iemlliibb22_setup(void)
{
    iemlliibb22_class = class_new(gensym("iemlib2"), iemlliibb22_new, 0,
    	sizeof(t_object), CLASS_NOINLET, 0);
}

/* ------------------------ setup routine ------------------------- */

void iemlib2_setup(void)
{
    speedlim_setup();
    iem_anything_setup();
    init_setup();
    prepend_setup();
    toggle_mess_setup();
    unsymbol_setup();
    sigLFO_noise_setup();
    sigfade_setup();
    sigm2f_setup();
    iemlliibb22_setup();
}
